package it.uniroma2.art.owlart.model.syntax.manchester;

import java.io.File;
import java.io.IOException;

import it.uniroma2.art.owlart.models.OWLModel;
import it.uniroma2.art.owlart.exceptions.ModelAccessException;
import it.uniroma2.art.owlart.exceptions.UnsupportedRDFFormatException;
import it.uniroma2.art.owlart.io.RDFFormat;



public class ClassExpression {
	public OWLModel model;
	public static String ontoURI;
	public static String repoDirName;
	public static String ontoLocPath;//utile solo in fase di test
	private ObjectUnionOf obj;



	public ClassExpression(OWLModel mod) {
	    model=mod;
	    ontoURI=mod.getBaseURI();
	    repoDirName="repository";
	    ontoLocPath="myOnt.owl";//utile solo in fase di test
	}

	//usato solo in fase di test
	public void saveRDFFile(OWLModel model) throws IOException, ModelAccessException, UnsupportedRDFFormatException{
	    model.writeRDF(new File(ontoLocPath), RDFFormat.RDFXML);
   }

	public ObjectUnionOf getObj() {
		return obj;
	}

	public void setObj(ObjectUnionOf obj) {
		this.obj = obj;
	}

}
